import os
import logging
from pyformance import MetricsRegistry

from pscr_common.metrics import get_reporter
from pscr_common.metadata import MetadataProvider

_logger = logging.getLogger(__name__)

def start_reporter(metrics_registry: MetricsRegistry):
    env = os.environ.get("ENV_ID", "unknown")
    env_meta = MetadataProvider().get_metadata()
    metrics_reporter = get_reporter(
        metrics_registry,
        env,
        env_meta.task_id,
        "index_registry",
        env_meta.image.split(":")[-1],
        str(os.getpid()),
        service_name_as_prefix=True
    )

    if metrics_reporter:
        # This starts a deamon thread
        reporter_started = metrics_reporter.start()

        if not reporter_started:
            _logger.warning("Metrics reporter thread failed to start.")
